

camera = {
   x = 0,
   y = 0,
   scaleX = 1,
   scaleY = 1,
   rotation = 0,
   shake = false
}

function camera:set()
   love.graphics.push()
   love.graphics.rotate(self.rotation)
   love.graphics.scale(1 / self.scaleX, 1 / self.scaleY)
   love.graphics.translate(self.x, self.y)
end

function camera:unset()
   love.graphics.pop()
end

function camera:move(dx, dy)
   self.x = self.x + (dx or 0)
   self.y = self.y + (dy or 0)
end

function camera:rotate(dr)
   self.rotation = self.rotation + dr
end

function camera:setPosition(x, y)
   self.x = x or self.x
   self.y = y or self.y
end

function camera:scale(sx, sy)
   self.scaleX = sx or self.scaleX
   self.scaleY = sy or self.scaleY
end

function camera:mousePosition()
   return love.mouse.getX() * self.scaleX + self.x, love.mouse.getY() * self.scaleY + self.y
end

function camera:shake(magnitude)
   for i = 1, 7 do
      if camera.shake then
	 camera:move(math.random(-magnitude, magnitude), math.random(-magnitude, magnitude))
	 camera.shake = false
      end
      cron.after(1, function() camera.shake = true end)
   end
end