

environment = {}
_environment = {}
for i = 1, 20 do
   _environment[i] = {}
   for j = 1, 20 do
      _environment[i][j] = {tile = nil, x = i, y = j}
   end
end

resources = {
   spritesheet = love.graphics.newImage("graphics/spritesheet.png")
}
resources.quads = {
   grass = love.graphics.newQuad(0, 0, 32, 32, resources.spritesheet:getWidth(), resources.spritesheet:getHeight())
}
local spritebatch = love.graphics.newSpriteBatch(resources.spritesheet, 600, "stream")


function environment:add(tile, x, y)
   _environment[x][y] = {tile = tile, x = x, y = y}
end

function environment:load(location)
   -- local file = love.filesystem.newFile(location)
   -- file:open("r")
   -- local content = file:read()

   local content = "1111111101010101000000000000000000000000000000000000000000000000000000000000000000000000000000000"
   local row = 1
   local column = 1

   for i = 1, 100 do
      if content:sub(i, i) == "0" then
	 environment:add(nil, column, row)
      elseif content:sub(i, i) == "1" then
	 environment:add("grass", column, row)
      end

      column = column + 1
      if column > 10 then
	 row = row + 1
	 column = 1
      end
   end
end
environment:load("maps/testmap.txt")

function environment:save(name)
   local final = ""

   for i = 1, 10 do
      for j = 1, 10 do
	 if _environment[i][j].tile then
	    final = final .. _environment[i][j].tile
	 else
	    final = final .. "0"
	 end
      end
   end

   love.filesystem.setIdentity("maps")
   love.filesystem.write(name .. ".txt", final)
end

function environment:draw()
   spritebatch:clear()
   for i = 1, 10 do
      for j = 1, 10 do
	 if _environment[i][j].tile then
	    spritebatch:add(resources.quads[_environment[i][j].tile], (_environment[i][j].x - 1) * 32, (_environment[i][j].y - 1) * 32)
	 end
      end
   end
   love.graphics.draw(spritebatch)
end